Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IHiveDao.cs	(revision 9434)
@@ -20,89 +20,148 @@
 #endregion
 
-
 using System;
 using System.Collections.Generic;
-using System.Linq;
+using System.Linq.Expressions;
 using HeuristicLab.Services.Hive.DataAccess;
 using DT = HeuristicLab.Services.Hive.DataTransfer;
+
 namespace HeuristicLab.Services.Hive {
   public interface IHiveDao {
     #region Task Methods
-    Task GetTaskById(Guid task);
-    Task GetTaskByDto(DT.Task taskDto);
-    Tuple<Task, Guid?> GetTaskByIdAndLastStateLogSlaveId(Guid taskId);
-
-    IEnumerable<TaskInfoForScheduler> GetWaitingTasks(Slave slave);
-    IQueryable<DT.LightweightTask> GetLightweightTasks(Guid jobId);
-
-    void UpdateTask(Task task);
-    Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception);
-
-    bool TaskIsAllowedToBeCalculatedBySlave(Guid taskId, Guid slaveId);
+    DT.Task GetTask(Guid id);
+    IEnumerable<DT.Task> GetTasks(Expression<Func<Task, bool>> predicate);
+    IEnumerable<DT.LightweightTask> GetLightweightTasks(Expression<Func<Task, bool>> predicate);
+    IEnumerable<DT.LightweightTask> GetLightweightTasksWithoutStateLog(Expression<Func<Task, bool>> predicate);
+    Guid AddTask(DT.Task dto);
+    void UpdateTaskAndPlugins(DT.Task dto);
+    void UpdateTaskAndStateLogs(DT.Task dto);
+    void UpdateTask(DT.Task dto);
+    void DeleteTask(Guid id);
+    IEnumerable<TaskInfoForScheduler> GetWaitingTasks(DT.Slave slave);
+    IEnumerable<DT.Task> GetParentTasks(IEnumerable<Guid> resourceIds, int count, bool finished);
+    DT.Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception);
     #endregion
 
     #region TaskData Methods
-    TaskData GetTaskDataByDto(DT.TaskData taskDataDto);
-    void UpdateTaskData(TaskData taskData);
+    DT.TaskData GetTaskData(Guid id);
+    IEnumerable<DT.TaskData> GetTaskDatas(Expression<Func<TaskData, bool>> predicate);
+    Guid AddTaskData(DT.TaskData dto);
+    void UpdateTaskData(DT.TaskData dto);
+    void DeleteTaskData(Guid id);
     #endregion
 
     #region StateLog Methods
-
+    DT.StateLog GetStateLog(Guid id);
+    IEnumerable<DT.StateLog> GetStateLogs(Expression<Func<StateLog, bool>> predicate);
+    Guid AddStateLog(DT.StateLog dto);
+    void UpdateStateLog(DT.StateLog dto);
+    void DeleteStateLog(Guid id);
     #endregion
 
     #region Job Methods
-
+    DT.Job GetJob(Guid id);
+    IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate);
+    IEnumerable<JobInfoForScheduler> GetJobInfoForScheduler(Expression<Func<Job, bool>> predicate);
+    Guid AddJob(DT.Job dto);
+    void UpdateJob(DT.Job dto);
+    void DeleteJob(Guid id);
     #endregion
 
     #region JobPermission Methods
-
+    DT.JobPermission GetJobPermission(Guid jobId, Guid grantedUserId);
+    IEnumerable<DT.JobPermission> GetJobPermissions(Expression<Func<JobPermission, bool>> predicate);
+    void AddJobPermission(DT.JobPermission dto);
+    void UpdateJobPermission(DT.JobPermission dto);
+    void DeleteJobPermission(Guid jobId, Guid grantedUserId);
+    void SetJobPermission(Guid jobId, Guid grantedByUserId, Guid grantedUserId, Permission permission);
     #endregion
 
     #region Plugin Methods
-    Plugin GetPluginById(Guid pluginId);
+    DT.Plugin GetPlugin(Guid id);
+    IEnumerable<DT.Plugin> GetPlugins(Expression<Func<Plugin, bool>> predicate);
+    Guid AddPlugin(DT.Plugin dto);
+    void UpdatePlugin(DT.Plugin dto);
+    void DeletePlugin(Guid id);
     #endregion
 
     #region PluginData Methods
-
+    DT.PluginData GetPluginData(Guid id);
+    IEnumerable<DT.PluginData> GetPluginDatas(Expression<Func<PluginData, bool>> predicate);
+    Guid AddPluginData(DT.PluginData dto);
+    void UpdatePluginData(DT.PluginData dto);
+    void DeletePluginData(Guid id);
     #endregion
 
     #region Slave Methods
-    Slave GetSlaveById(Guid id);
-
-    void UpdateSlave(Slave slave);
-
-    bool SlaveHasToShutdownComputer(Guid slaveId);
-    bool SlaveIsAllowedToCalculate(Guid slaveId);
+    DT.Slave GetSlave(Guid id);
+    IEnumerable<DT.Slave> GetSlaves(Expression<Func<Slave, bool>> predicate);
+    Guid AddSlave(DT.Slave dto);
+    void UpdateSlave(DT.Slave dto);
+    void DeleteSlave(Guid id);
     #endregion
 
     #region SlaveGroup Methods
-
+    DT.SlaveGroup GetSlaveGroup(Guid id);
+    IEnumerable<DT.SlaveGroup> GetSlaveGroups(Expression<Func<SlaveGroup, bool>> predicate);
+    Guid AddSlaveGroup(DT.SlaveGroup dto);
+    void UpdateSlaveGroup(DT.SlaveGroup dto);
+    void DeleteSlaveGroup(Guid id);
     #endregion
 
     #region Resource Methods
-
+    DT.Resource GetResource(Guid id);
+    IEnumerable<DT.Resource> GetResources(Expression<Func<Resource, bool>> predicate);
+    Guid AddResource(DT.Resource dto);
+    void UpdateResource(DT.Resource dto);
+    void DeleteResource(Guid id);
+    void AssignJobToResource(Guid taskId, IEnumerable<Guid> resourceIds);
+    IEnumerable<DT.Resource> GetAssignedResources(Guid jobId);
+    IEnumerable<DT.Resource> GetParentResources(Guid resourceId);
+    IEnumerable<DT.Resource> GetChildResources(Guid resourceId);
+    IEnumerable<DT.Task> GetJobsByResourceId(Guid resourceId);
     #endregion
 
     #region ResourcePermission Methods
-
+    DT.ResourcePermission GetResourcePermission(Guid resourceId, Guid grantedUserId);
+    IEnumerable<DT.ResourcePermission> GetResourcePermissions(Expression<Func<ResourcePermission, bool>> predicate);
+    void AddResourcePermission(DT.ResourcePermission dto);
+    void UpdateResourcePermission(DT.ResourcePermission dto);
+    void DeleteResourcePermission(Guid resourceId, Guid grantedUserId);
     #endregion
 
     #region Authorization Methods
-
+    Permission GetPermissionForTask(Guid taskId, Guid userId);
+    Permission GetPermissionForJob(Guid jobId, Guid userId);
+    Guid GetJobForTask(Guid taskId);
     #endregion
 
     #region Lifecycle Methods
-
+    DateTime GetLastCleanup();
+    void SetLastCleanup(DateTime datetime);
     #endregion
 
     #region Downtime Methods
+    DT.Downtime GetDowntime(Guid id);
+    IEnumerable<DT.Downtime> GetDowntimes(Expression<Func<Downtime, bool>> predicate);
+    Guid AddDowntime(DT.Downtime dto);
+    void UpdateDowntime(DT.Downtime dto);
+    void DeleteDowntime(Guid id);
     #endregion
 
     #region Statistics Methods
-
+    Dictionary<Guid, int> GetWaitingTasksByUser();
+    Dictionary<Guid, int> GetWaitingTasksByUserForResources(List<Guid> resourceIds);
+    Dictionary<Guid, int> GetCalculatingTasksByUser();
+    Dictionary<Guid, int> GetCalculatingTasksByUserForResources(List<Guid> resourceIds);
+    DT.Statistics GetStatistic(Guid id);
+    IEnumerable<DT.Statistics> GetStatistics(Expression<Func<Statistics, bool>> predicate);
+    Guid AddStatistics(DT.Statistics dto);
+    void DeleteStatistics(Guid id);
+    List<DT.UserStatistics> GetUserStatistics();
     #endregion
 
     #region UserPriority Methods
-
+    IEnumerable<DT.UserPriority> GetUserPriorities(Expression<Func<UserPriority, bool>> predicate);
+    void EnqueueUserPriority(DT.UserPriority userPriority);
     #endregion
   }
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs	(revision 9434)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs	(revision 9434)
@@ -0,0 +1,112 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.Hive.DataTransfer;
+namespace HeuristicLab.Services.Hive {
+  public interface IOptimizedHiveDao {
+    #region Task Methods
+    Task GetTaskById(Guid task);
+    Task GetTaskByDto(DT.Task taskDto);
+    Tuple<Task, Guid?> GetTaskByIdAndLastStateLogSlaveId(Guid taskId);
+
+    IEnumerable<TaskInfoForScheduler> GetWaitingTasks(Slave slave);
+    IQueryable<DT.LightweightTask> GetLightweightTasks(Guid jobId);
+
+    void UpdateTask(Task task);
+    Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception);
+
+    Guid AddTask(Task task);
+    void AssignJobToResource(Guid taskId, IEnumerable<Guid> resourceIds);
+
+    bool TaskIsAllowedToBeCalculatedBySlave(Guid taskId, Guid slaveId);
+    #endregion
+
+    #region TaskData Methods
+    TaskData GetTaskDataByDto(DT.TaskData taskDataDto);
+    void UpdateTaskData(TaskData taskData);
+    #endregion
+
+    #region StateLog Methods
+
+    #endregion
+
+    #region Job Methods
+
+    #endregion
+
+    #region JobPermission Methods
+
+    #endregion
+
+    #region Plugin Methods
+    Plugin GetPluginById(Guid pluginId);
+    #endregion
+
+    #region PluginData Methods
+
+    #endregion
+
+    #region Slave Methods
+    Slave GetSlaveById(Guid id);
+
+    void UpdateSlave(Slave slave);
+
+    bool SlaveHasToShutdownComputer(Guid slaveId);
+    bool SlaveIsAllowedToCalculate(Guid slaveId);
+    #endregion
+
+    #region SlaveGroup Methods
+
+    #endregion
+
+    #region Resource Methods
+    IEnumerable<Guid> GetAssignedResourceIds(Guid jobId);
+    #endregion
+
+    #region ResourcePermission Methods
+
+    #endregion
+
+    #region Authorization Methods
+
+    #endregion
+
+    #region Lifecycle Methods
+
+    #endregion
+
+    #region Downtime Methods
+    #endregion
+
+    #region Statistics Methods
+
+    #endregion
+
+    #region UserPriority Methods
+
+    #endregion
+  }
+}
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IServiceLocator.cs	(revision 9434)
@@ -26,6 +26,6 @@
     Access.IRoleVerifier RoleVerifier { get; }
     IAuthorizationManager AuthorizationManager { get; }
-    IHiveDtoDao HiveDtoDao { get; }
     IHiveDao HiveDao { get; }
+    IOptimizedHiveDao OptimizedHiveDao { get; }
     IEventManager EventManager { get; }
     ITransactionManager TransactionManager { get; }
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 9434)
@@ -36,5 +36,5 @@
       if (ServiceLocator.Instance.RoleVerifier.IsInRole(HiveRoles.Slave)) return; // slave-users can access all tasks
 
-      Permission permission = ServiceLocator.Instance.HiveDtoDao.GetPermissionForTask(taskId, ServiceLocator.Instance.UserManager.CurrentUserId);
+      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForTask(taskId, ServiceLocator.Instance.UserManager.CurrentUserId);
       if (permission == Permission.NotAllowed || (permission != DT.Convert.ToEntity(requiredPermission) && DT.Convert.ToEntity(requiredPermission) == Permission.Full))
         throw new SecurityException("Current user is not authorized to access task");
@@ -42,5 +42,5 @@
 
     public void AuthorizeForJob(Guid jobId, DT.Permission requiredPermission) {
-      Permission permission = ServiceLocator.Instance.HiveDtoDao.GetPermissionForJob(jobId, ServiceLocator.Instance.UserManager.CurrentUserId);
+      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForJob(jobId, ServiceLocator.Instance.UserManager.CurrentUserId);
       if (permission == Permission.NotAllowed || (permission != DT.Convert.ToEntity(requiredPermission) && DT.Convert.ToEntity(requiredPermission) == Permission.Full))
         throw new SecurityException("Current user is not authorized to access task");
@@ -48,5 +48,5 @@
 
     public void AuthorizeForResourceAdministration(Guid resourceId) {
-      Resource resource = DT.Convert.ToEntity(ServiceLocator.Instance.HiveDtoDao.GetResource(resourceId));
+      Resource resource = DT.Convert.ToEntity(ServiceLocator.Instance.HiveDao.GetResource(resourceId));
       if (resource.OwnerUserId != ServiceLocator.Instance.UserManager.CurrentUserId && !ServiceLocator.Instance.RoleVerifier.IsInRole(HiveRoles.Administrator))
         throw new SecurityException("Current user is not authorized to access resource");
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 9434)
@@ -32,6 +32,6 @@
   /// </summary>
   public class EventManager : IEventManager {
-    private IHiveDtoDao dao {
-      get { return ServiceLocator.Instance.HiveDtoDao; }
+    private IHiveDao dao {
+      get { return ServiceLocator.Instance.HiveDao; }
     }
     private IAuthorizationManager auth {
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 9434)
@@ -31,6 +31,6 @@
     private const string MutexName = "HiveTaskSchedulingMutex";
 
-    private IHiveDao dao {
-      get { return ServiceLocator.Instance.HiveDao; }
+    private IOptimizedHiveDao dao {
+      get { return ServiceLocator.Instance.OptimizedHiveDao; }
     }
     private ITaskScheduler taskScheduler {
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs	(revision 9434)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs	(revision 9434)
@@ -0,0 +1,294 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Linq;
+using DT = HeuristicLab.Services.Hive.DataTransfer;
+
+namespace HeuristicLab.Services.Hive.DataAccess {
+  public class OptimizedHiveDao : IOptimizedHiveDao {
+    private static HiveDataContext Db { get { return HiveOperationContext.Current.DataContext; } }
+
+    #region Task Methods
+    public Task GetTaskById(Guid taskId) {
+      return GetTaskByIdQuery(Db, taskId).SingleOrDefault();
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<Task>> GetTaskByIdQuery = CompiledQuery.Compile((HiveDataContext db, Guid taskId) =>
+      from t in db.Tasks
+      where t.TaskId == taskId
+      select t
+    );
+
+    public Task GetTaskByDto(DT.Task taskDto) {
+      var task = GetTaskById(taskDto.Id);
+      DT.Convert.ToEntity(taskDto, task);
+      return task;
+    }
+
+    public Tuple<Task, Guid?> GetTaskByIdAndLastStateLogSlaveId(Guid taskId) {
+      return GetTaskByIdAndLastStateLogSlaveIdQuery(Db, taskId).SingleOrDefault();
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<Tuple<Task, Guid?>>> GetTaskByIdAndLastStateLogSlaveIdQuery = CompiledQuery.Compile((HiveDataContext db, Guid taskId) =>
+       from t in db.Tasks
+       join sl in db.StateLogs on t.TaskId equals sl.TaskId
+       where t.TaskId == taskId
+       orderby sl.DateTime descending
+       group sl by t into logs
+       select new Tuple<Task, Guid?>(logs.Key, logs.First().SlaveId)
+    );
+
+    private const string GetWaitingTasksQueryString = @"
+      WITH pr AS (
+        SELECT ResourceId, ParentResourceId
+        FROM [Resource]
+        WHERE ResourceId = {0}
+        UNION ALL
+        SELECT r.ResourceId, r.ParentResourceId
+        FROM [Resource] r JOIN pr ON r.ResourceId = pr.ParentResourceId
+      )
+      SELECT DISTINCT t.TaskId, t.JobId, t.Priority
+      FROM pr JOIN AssignedResources ar ON ar.ResourceId = pr.ResourceId
+          JOIN Task t ON t.TaskId = ar.TaskId
+      WHERE NOT (t.IsParentTask = 1 AND t.FinishWhenChildJobsFinished = 1)
+          AND t.TaskState = {1}
+          AND t.CoresNeeded <= {2}
+          AND t.MemoryNeeded <= {3}
+    ";
+
+    public IEnumerable<TaskInfoForScheduler> GetWaitingTasks(Slave slave) {
+      //Originally we checked here if there are parent tasks which should be calculated (with GetParentTasks(resourceIds, count, false);).
+      //Because there is at the moment no case where this makes sense (there don't exist parent tasks which need to be calculated), 
+      //we skip this step because it's wasted runtime
+      return Db.ExecuteQuery<TaskInfoForScheduler>(GetWaitingTasksQueryString, slave.ResourceId, Enum.GetName(typeof(TaskState), TaskState.Waiting), slave.FreeCores, slave.FreeMemory);
+    }
+
+    public IQueryable<DT.LightweightTask> GetLightweightTasks(Guid jobId) {
+      return GetLightweightTasksQuery(Db, jobId);
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<DT.LightweightTask>> GetLightweightTasksQuery = CompiledQuery.Compile((HiveDataContext db, Guid jobId) =>
+        from task in db.Tasks
+        where task.JobId == jobId
+        select new DT.LightweightTask {
+          Id = task.TaskId,
+          ExecutionTime = TimeSpan.FromMilliseconds(task.ExecutionTimeMs),
+          ParentTaskId = task.ParentTaskId,
+          StateLog = task.StateLogs.Select(sl => ConvertStateLog(sl)).ToList(),
+          State = ConvertTaskState(task.State),
+          Command = ConvertCommand(task.Command),
+          LastTaskDataUpdate = task.JobData.LastUpdate
+        }
+    );
+
+    private static readonly Func<StateLog, DT.StateLog> ConvertStateLog = sl => DT.Convert.ToDto(sl);
+    private static readonly Func<TaskState, DT.TaskState> ConvertTaskState = ts => DT.Convert.ToDto(ts);
+    private static readonly Func<Command?, DT.Command?> ConvertCommand = c => DT.Convert.ToDto(c);
+
+    public void UpdateTask(Task task) {
+      Db.SubmitChanges();
+    }
+
+    public Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception) {
+      Db.StateLogs.InsertOnSubmit(new StateLog {
+        TaskId = taskId,
+        State = taskState,
+        SlaveId = slaveId,
+        UserId = userId,
+        Exception = exception,
+        DateTime = DateTime.Now
+      });
+
+      var task = GetTaskById(taskId);
+      task.State = taskState;
+
+      Db.SubmitChanges();
+
+      return task;
+    }
+
+    public Guid AddTask(Task task) {
+      Db.Tasks.InsertOnSubmit(task);
+      Db.SubmitChanges();
+      return task.TaskId;
+    }
+
+    public void AssignJobToResource(Guid taskId, IEnumerable<Guid> resourceIds) {
+      Db.AssignedResources.InsertAllOnSubmit(resourceIds.Select(resourceId => new AssignedResource { TaskId = taskId, ResourceId = resourceId }));
+      Db.SubmitChanges();
+    }
+
+    private const string TaskIsAllowedToBeCalculatedBySlaveQueryString = @"
+      WITH pr AS (
+        SELECT ResourceId, ParentResourceId
+        FROM [Resource]
+        WHERE ResourceId = {0}
+        UNION ALL
+        SELECT r.ResourceId, r.ParentResourceId
+        FROM [Resource] r JOIN pr ON r.ResourceId = pr.ParentResourceId
+      )
+      SELECT COUNT(ar.TaskId)
+      FROM pr JOIN AssignedResources ar ON pr.ResourceId = ar.ResourceId
+      WHERE ar.TaskId = {1}
+    ";
+
+    public bool TaskIsAllowedToBeCalculatedBySlave(Guid taskId, Guid slaveId) {
+      return Db.ExecuteQuery<int>(TaskIsAllowedToBeCalculatedBySlaveQueryString, slaveId, taskId).First() > 0;
+    }
+    #endregion
+
+    #region TaskData Methods
+    public TaskData GetTaskDataById(Guid id) {
+      return GetTaskDataByIdQuery(Db, id).SingleOrDefault();
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<TaskData>> GetTaskDataByIdQuery = CompiledQuery.Compile((HiveDataContext db, Guid id) =>
+      from t in db.TaskDatas
+      where t.TaskId == id
+      select t
+    );
+
+    public TaskData GetTaskDataByDto(DT.TaskData dto) {
+      var taskData = GetTaskDataById(dto.TaskId);
+      DT.Convert.ToEntity(dto, taskData);
+      return taskData;
+    }
+
+    public void UpdateTaskData(TaskData taskData) {
+      Db.SubmitChanges();
+    }
+    #endregion
+
+    #region StateLog Methods
+
+    #endregion
+
+    #region Job Methods
+
+    #endregion
+
+    #region JobPermission Methods
+
+    #endregion
+
+    #region Plugin Methods
+    public Plugin GetPluginById(Guid pluginId) {
+      return GetPluginByIdQuery(Db, pluginId).SingleOrDefault();
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<Plugin>> GetPluginByIdQuery = CompiledQuery.Compile((HiveDataContext db, Guid pluginId) =>
+      from p in db.Plugins
+      where p.PluginId == pluginId
+      select p
+    );
+
+    #endregion
+
+    #region PluginData Methods
+
+    #endregion
+
+    #region Slave Methods
+    public Slave GetSlaveById(Guid id) {
+      return GetSlaveByIdQuery(Db, id).SingleOrDefault();
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<Slave>> GetSlaveByIdQuery = CompiledQuery.Compile((HiveDataContext db, Guid slaveId) =>
+      from s in db.Resources.OfType<Slave>()
+      where s.ResourceId == slaveId
+      select s
+    );
+
+    public void UpdateSlave(Slave slave) {
+      Db.SubmitChanges();
+    }
+
+    private const string DowntimeQueryString = @"
+      WITH pr AS (
+        SELECT ResourceId, ParentResourceId
+        FROM [Resource]
+        WHERE ResourceId = {0}
+        UNION ALL
+        SELECT r.ResourceId, r.ParentResourceId
+        FROM [Resource] r JOIN pr ON r.ResourceId = pr.ParentResourceId
+      )
+      SELECT COUNT(dt.DowntimeId)
+      FROM pr JOIN [Downtime] dt ON pr.ResourceId = dt.ResourceId
+      WHERE {1} BETWEEN dt.StartDate AND dt.EndDate
+        AND dt.DowntimeType = {2}
+      ";
+
+    public bool SlaveHasToShutdownComputer(Guid slaveId) {
+      return Db.ExecuteQuery<int>(DowntimeQueryString, slaveId, DateTime.Now, DowntimeType.Shutdown).First() > 0;
+    }
+
+    public bool SlaveIsAllowedToCalculate(Guid slaveId) {
+      return Db.ExecuteQuery<int>(DowntimeQueryString, slaveId, DateTime.Now, DowntimeType.Offline).First() == 0;
+    }
+    #endregion
+
+    #region SlaveGroup Methods
+
+    #endregion
+
+    #region Resource Methods
+    public IEnumerable<Guid> GetAssignedResourceIds(Guid taskId) {
+      return GetAssignedResourceIdsQuery(Db, taskId);
+    }
+
+    private static readonly Func<HiveDataContext, Guid, IQueryable<Guid>> GetAssignedResourceIdsQuery = CompiledQuery.Compile((HiveDataContext db, Guid taskId) =>
+      from ar in db.AssignedResources
+      where ar.TaskId == taskId
+      select ar.ResourceId
+    );
+    #endregion
+
+    #region ResourcePermission Methods
+
+    #endregion
+
+    #region Authorization Methods
+
+    #endregion
+
+    #region Lifecycle Methods
+
+    #endregion
+
+    #region Downtime Methods
+    #endregion
+
+    #region Statistics Methods
+
+    #endregion
+
+    #region UserPriority Methods
+
+    #endregion
+
+    #region Helpers
+
+    #endregion
+  }
+}
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Scheduler/RoundRobinTaskScheduler.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Scheduler/RoundRobinTaskScheduler.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Scheduler/RoundRobinTaskScheduler.cs	(revision 9434)
@@ -27,6 +27,6 @@
 namespace HeuristicLab.Services.Hive {
   public class RoundRobinTaskScheduler : ITaskScheduler {
-    private IHiveDtoDao dao {
-      get { return ServiceLocator.Instance.HiveDtoDao; }
+    private IHiveDao dao {
+      get { return ServiceLocator.Instance.HiveDao; }
     }
 
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 9433)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 9434)
@@ -34,12 +34,4 @@
     }
 
-    private IHiveDtoDao hiveDtoDao;
-    public IHiveDtoDao HiveDtoDao {
-      get {
-        if (hiveDtoDao == null) hiveDtoDao = new HiveDtoDao();
-        return hiveDtoDao;
-      }
-    }
-
     private IHiveDao hiveDao;
     public IHiveDao HiveDao {
@@ -47,4 +39,12 @@
         if (hiveDao == null) hiveDao = new HiveDao();
         return hiveDao;
+      }
+    }
+
+    private IOptimizedHiveDao optimizedHiveDao;
+    public IOptimizedHiveDao OptimizedHiveDao {
+      get {
+        if (optimizedHiveDao == null) optimizedHiveDao = new OptimizedHiveDao();
+        return optimizedHiveDao;
       }
     }
